/**
 *  LinkedList class
 *
 * A singly-linked collection class of Nodes. Allows a Node to be
 * inserted at the beginning of the list, the end of the list, or in
 * order as long as the Node data is Object. Can also determine if
 * an element is in the list, as well as whether it is empty, or the
 * number of elements in the list
 *
 * You must write a method that will filter the list based on a
 * Comparable passed as a parameter.
 *
 * @author Dominic Jonak, et al.
 * @Date 9/25/02
 */

public class LinkedList
{

    private Node head;

    /**
     *	default constructor, initializes to an empty list
     */

    public LinkedList()
    {
	head = null;
    }

    /**
     *	does the list have any values?
     *
     *	@return true if list is empty, false otherwise
     */

    public boolean isEmpty()
    {
	return head == null;
    }

    /**
     *	inserts the obj at the beginning of the list
     *
     *	@param the object to be inserted
     */
    
    public void prepend(Comparable obj)
    {
	head = new Node(obj,head);
    }

    /**
     *	Returns all the elements of this list as a String
     *
     *	@return list of elements
     */

    public String toString()
    {
	String result = "";

	for (Node curr = head; curr != null; curr = curr.getNext())
	    result += curr.getData() + System.getProperty("line.separator");

	return result;
    }

    /**
     * Removes all elements from the list that are greater than the 
     * parameter.
     *
     * @param the object to compare with
     *
     * You must implement this method
     */

}
