/**
 *  Class Player
 *
 * A class that models a player in a golf tournament.
 *
 * @author Dominic Jonak, et al.
 * @Date 9/25/02
 *
 * 15-200
 * Name:
 * Section:
 * andrew e-mail:
 */

public class Player implements Comparable
{
    private String firstName;
    private String lastName;
    private int round1, round2, total;

    /**
     *	constructor builds the player with the supplied parameters
     *
     *	@param first name of the player
     *	@param last name of the player
     *	@param score of first round
     *	@param score of second round
     */

    public Player(String fn, String ln, int r1, int r2)
    {
	firstName = fn;
	lastName = ln;
	round1 = r1;
	round2 = r2;
	total = r1 + r2;
    }

    /**
     *	constructor builds the player with default values
     */
    
    public Player()
    {
	firstName = "";
	lastName = "";
	round1 = 0;
	round2 = 0;
	total =0;
    }

    /**
     *	returns first name of the player
     *
     *	@return first name of player
     */

    public String  getFName()
    {
	return  firstName;
    }
    
    /**
     *	returns last name of the player
     *
     *	@return last name of player
     */

    public String  getLName()
    {
	return  lastName;
    }

    /**
     *	returns first round score
     *
     *	@return first round score
     */

    public int  getRound1()
    {
	return  round1;
    }

    /**
     *	returns second round score
     *
     *	@return second round score
     */

    public int  getRound2()
    {
	return  round2;
    }

    /**
     *	returns total score
     *
     *	@return total score
     */

    public int  getTotal()
    {
	return  total;
    }

    /**
     *	returns player information as a String
     *
     *	@return last name, first name, round 1 score, round 2 score, total score
     */

    public String toString()
    {
	String str = getLName() + ", " + getFName() + " " +
	    getRound1() + " " +  getRound2() + " " +
	    getTotal();
	
	return str;
    }

    /**
     * Compares two Players based on their score
     *
     * If not passed a Player, 0 is returned
     *
     * @param Player object to compare with
     *
     * @return <0 if the passed player has a lower score
     *          0 if the scores are equal
     *         >0 if the passed player has a higher score
     */

    public int compareTo(Object obj){
	try{
	    return this.total - ((Player)obj).total;
	}catch(Exception e){}

	//casting failed if the parameter is not a Player
	return 0;
    }

}
